--- chan_iax2.c	2005-10-30 12:11:19.000000000 -0500
+++ chan_iax2.c.new	2005-10-30 12:00:49.000000000 -0500
@@ -2211,6 +2211,7 @@
  * make preprocessor swiss-cheese out of this one.  I'm not sure which is less revolting.. */
 static int schedule_delivery(struct iax_frame *fr, int updatehistory, int fromtrunk)
 {
+	int abk_rxstamp;
 #ifdef NEWJB
 	int type, len;
 	int ret;
@@ -2365,8 +2366,21 @@
 
 	/* insert into jitterbuffer */
 	/* TODO: Perhaps we could act immediately if it's not droppable and late */
+
+if(fr->ts < 0) {
+	ast_log(LOG_ERROR, "call %s-%u: fr->ts is -ve, zeroing!", iaxs[fr->callno]->peer, iaxs[fr->callno]->callno);
+	fr->ts = 0;
+	}
+
+abk_rxstamp = calc_rxstamp(iaxs[fr->callno],fr->ts);
+
+if(abk_rxstamp < 0) {
+	ast_log(LOG_ERROR, "call %s-%u: calc_rxstamp returned -ve, zeroing!", iaxs[fr->callno]->peer, iaxs[fr->callno]->callno);
+	abk_rxstamp = 0;
+	}
+
 	ret = jb_put(iaxs[fr->callno]->jb, fr, type, len, fr->ts,
-			calc_rxstamp(iaxs[fr->callno],fr->ts));
+			abk_rxstamp);
 	if (ret == JB_DROP) {
 		iax2_frame_free(fr);
 	} else if (ret == JB_SCHED) {
